
;CodeVisionAVR C Compiler V1.25.9 Professional
;(C) Copyright 1998-2008 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type              : ATmega48V
;Clock frequency        : 1,000000 MHz
;Memory model           : Small
;Optimize for           : Speed
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External SRAM size     : 0
;Data Stack size        : 128 byte(s)
;Heap size              : 0 byte(s)
;Promote char to int    : No
;char is unsigned       : Yes
;8 bit enums            : Yes
;Word align FLASH struct: No
;Enhanced core instructions    : On
;Smart register allocation : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega48V
	#pragma AVRPART MEMORY PROG_FLASH 4096
	#pragma AVRPART MEMORY EEPROM 256
	#pragma AVRPART MEMORY INT_SRAM SIZE 512
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x100

	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU EECR=0x1F
	.EQU EEDR=0x20
	.EQU EEARL=0x21
	.EQU EEARH=0x22
	.EQU SPSR=0x2D
	.EQU SPDR=0x2E
	.EQU SMCR=0x33
	.EQU MCUSR=0x34
	.EQU MCUCR=0x35
	.EQU WDTCSR=0x60
	.EQU UCSR0A=0xC0
	.EQU UDR0=0xC6
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F
	.EQU GPIOR0=0x1E

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ANDI R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ORI  R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	LDI  R30,0
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	LDI  R22,BYTE3(2*@0+@1)
	LDI  R23,BYTE4(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+@3)
	LDI  R@1,HIGH(@2*2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+@2
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+@3
	LDS  R@1,@2+@3+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+@1,R0
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	RCALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	RCALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "sequrity.vec"
	.INCLUDE "sequrity.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	WDR
	IN   R26,MCUSR
	CBR  R26,8
	OUT  MCUSR,R26
	STS  WDTCSR,R31
	STS  WDTCSR,R30

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x200)
	LDI  R25,HIGH(0x200)
	LDI  R26,LOW(0x100)
	LDI  R27,HIGH(0x100)
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;GPIOR0 INITIALIZATION
	LDI  R30,__GPIOR0_INIT
	OUT  GPIOR0,R30

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x2FF)
	OUT  SPL,R30
	LDI  R30,HIGH(0x2FF)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x180)
	LDI  R29,HIGH(0x180)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x180
;       1 /*****************************************************
;       2 This program was produced by the
;       3 CodeWizardAVR V1.25.9 Professional
;       4 Automatic Program Generator
;       5  Copyright 1998-2008 Pavel Haiduc, HP InfoTech s.r.l.
;       6 http://www.hpinfotech.com
;       7 
;       8 Project :
;       9 Version :
;      10 Date    : 07.04.2009
;      11 Author  : Dikoy
;      12 Company : NT
;      13 Comments:
;      14 
;      15 
;      16 Chip type           : ATmega48V
;      17 Clock frequency     : 1,000000 MHz
;      18 Memory model        : Small
;      19 External SRAM size  : 0
;      20 Data Stack size     : 128
;      21 *****************************************************/
;      22 
;      23 #include <mega48.h>
;      24 	#ifndef __SLEEP_DEFINED__
	#ifndef __SLEEP_DEFINED__
;      25 	#define __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
;      26 	.EQU __se_bit=0x01
	.EQU __se_bit=0x01
;      27 	.EQU __sm_mask=0x0E
	.EQU __sm_mask=0x0E
;      28 	.EQU __sm_adc_noise_red=0x02
	.EQU __sm_adc_noise_red=0x02
;      29 	.EQU __sm_powerdown=0x04
	.EQU __sm_powerdown=0x04
;      30 	.EQU __sm_powersave=0x06
	.EQU __sm_powersave=0x06
;      31 	.EQU __sm_standby=0x0C
	.EQU __sm_standby=0x0C
;      32 	.SET power_ctrl_reg=smcr
	.SET power_ctrl_reg=smcr
;      33 	#endif
	#endif
;      34 #include <sleep.h>
;      35 #include <delay.h>
;      36 
;      37 
;      38 #define PWM_OUT     5
;      39 #define BUSSER_ON   PORTD |= (1<<1)
;      40 #define BUSSER_OFF  PORTD &= ~(1<<1)
;      41 #define BAT_CHARGE  0x0E
;      42 #define X_AXIS 2
;      43 #define Y_AXIS 3
;      44 #define Z_AXIS 4
;      45 #define RESISTOR 6
;      46 #define PWM_FB   7
;      47 #define AX_SLEEP_MODE  PORTC&=~(1<<5) //    
;      48 #define AX_WAKE_UP     PORTC|=(1<<5)  //  
;      49 #define AVCC_SOURCE  0x60  //    - 
;      50 #define AINT_SOURCE  0xE0  //  
;      51 #define MIN_STEPUP_LEVEL   (226+10)  //      , 13,7V
;      52 #define MAX_STEPUP_LEVEL   (228+10)  //      , 14V
;      53 #define DIVIDER_ON   DDRB|=(1<<7)
;      54 #define DIVIDER_OFF  DDRB&=~(1<<7)
;      55 #define RESISTOR_ON   DDRB|=(1<<5)
;      56 #define RESISTOR_OFF  DDRB&=~(1<<5)
;      57 #define KNOPA_PRESSED  ( !(PINB & (1<<0)) )
;      58 #define ALARM_DIVIDER   4
;      59 
;      60 
;      61 // *** ***
;      62 unsigned char temp, time_of_pressed;
;      63 unsigned char sleep_mode_flag = 0;
;      64 unsigned char ALARM_flag = 0;
;      65 unsigned char sequrity_flag = 0;
;      66 unsigned char zero_X, zero_Y, zero_Z, zero_R;
;      67 unsigned char min_X, min_Y, min_Z;
;      68 unsigned char max_X, max_Y, max_Z;
_max_X:
	.BYTE 0x1
_max_Y:
	.BYTE 0x1
_max_Z:
	.BYTE 0x1
;      69 unsigned int  alarm_count = 0;
_alarm_count:
	.BYTE 0x2
;      70 unsigned char bt_flag = 0;
_bt_flag:
	.BYTE 0x1
;      71 
;      72 unsigned int button_count = 0;
_button_count:
	.BYTE 0x2
;      73 unsigned int but_count = 0;
_but_count:
	.BYTE 0x2
;      74 
;      75 //unsigned char first_flag = 1;
;      76 
;      77 // ******
;      78 
;      79 // Pin change 0-7 interrupt service routine
;      80 interrupt [PCINT0] void pin_change_isr0(void)
;      81 {

	.CSEG
_pin_change_isr0:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R15
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
;      82 if(sequrity_flag == 0) {
	TST  R8
	BRNE _0x3
;      83         while(KNOPA_PRESSED);
_0x4:
	SBIS 0x3,0
	RJMP _0x4
;      84         sleep_mode_flag = 1;
	LDI  R30,LOW(1)
	MOV  R6,R30
;      85         #asm("cli")
	cli
;      86         delay_ms(500);
	LDI  R30,LOW(500)
	LDI  R31,HIGH(500)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
;      87         }
;      88 }
_0x3:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI
;      89 
;      90 
;      91 // Watchdog timeout interrupt service routine
;      92 interrupt [WDT] void wdt_timeout_isr(void) {
_wdt_timeout_isr:
;      93 
;      94         #asm("nop")
	nop
;      95 
;      96 }
	RETI
;      97 
;      98 void wdt_start(void) {
_wdt_start:
;      99         // Watchdog Timer initialization
;     100         // Watchdog Timer Prescaler: OSC/64k
;     101         // Watchdog Timer interrupt: On
;     102         #pragma optsize-
;     103         #asm("wdr")
	wdr
;     104         WDTCSR = (1<<4) | (1<<3);  // (1<<WDCE) | (1<<WDE)
	LDI  R30,LOW(24)
	STS  96,R30
;     105         WDTCSR = (1<<6) | (1<<2) | (1<<0);  // (1<<WDIE) | (1<<WDP2) | (1<<WDP0)
	LDI  R30,LOW(69)
	STS  96,R30
;     106 
;     107         #ifdef _OPTIMIZE_SIZE_
;     108         #pragma optsize+
;     109         #endif
;     110 
;     111         // Global enable interrupts
;     112         #asm("sei")
	sei
;     113 }
	RET
;     114 
;     115 
;     116 void wdt_stop(void) {
_wdt_stop:
;     117         #pragma optsize-
;     118         #asm("wdr")
	wdr
;     119         WDTCSR = (1<<4) | (1<<3);  // (1<<WDCE) | (1<<WDE)
	LDI  R30,LOW(24)
	STS  96,R30
;     120         WDTCSR = 0;
	LDI  R30,LOW(0)
	STS  96,R30
;     121         #ifdef _OPTIMIZE_SIZE_
;     122         #pragma optsize+
;     123         #endif
;     124 
;     125         #asm("cli")
	cli
;     126 }
	RET
;     127 
;     128 
;     129 
;     130 // Read the 8 most significant bits
;     131 // of the AD conversion result
;     132 unsigned char read_adc(unsigned char adc_par)
;     133 {
_read_adc:
;     134 ADMUX = adc_par;
;	adc_par -> Y+0
	LD   R30,Y
	STS  124,R30
;     135 // Delay needed for the stabilization of the ADC input voltage
;     136 delay_us(10);
	__DELAY_USB 3
;     137 // Start the AD conversion
;     138 ADCSRA|=0x40;
	LDS  R30,122
	ORI  R30,0x40
	STS  122,R30
;     139 // Wait for the AD conversion to complete
;     140 while ((ADCSRA & 0x10)==0);
_0x7:
	LDS  R30,122
	ANDI R30,LOW(0x10)
	BREQ _0x7
;     141 ADCSRA|=0x10;
	LDS  R30,122
	ORI  R30,0x10
	STS  122,R30
;     142 return ADCH;
	LDS  R30,121
	ADIW R28,1
	RET
;     143 }
;     144 
;     145 
;     146 void start_PWM(void) {
_start_PWM:
;     147 // Timer/Counter 0 initialization
;     148 // Clock source: System Clock
;     149 // Clock value: 1000,000 kHz
;     150 // Mode: CTC top=OCR0A
;     151 // OC0A output: Disconnected
;     152 // OC0B output: Toggle on compare match
;     153 TCCR0A=0x12;
	LDI  R30,LOW(18)
	OUT  0x24,R30
;     154 TCCR0B=0x01;
	LDI  R30,LOW(1)
	OUT  0x25,R30
;     155 }
	RET
;     156 
;     157 void PWM_stop(void) {
_PWM_stop:
;     158 TCCR0A=0x00;
	LDI  R30,LOW(0)
	OUT  0x24,R30
;     159 TCCR0B=0x00;
	OUT  0x25,R30
;     160 
;     161 PORTD &= ~(1<<PWM_OUT);
	CBI  0xB,5
;     162 }
	RET
;     163 
;     164 
;     165 void Step_Up_Process(void) {
_Step_Up_Process:
;     166 unsigned char u_fb;
;     167 
;     168         u_fb = read_adc(AINT_SOURCE | PWM_FB);
	ST   -Y,R17
;	u_fb -> R17
	LDI  R30,LOW(231)
	ST   -Y,R30
	RCALL _read_adc
	MOV  R17,R30
;     169 
;     170         if( u_fb < MIN_STEPUP_LEVEL  ) start_PWM();
	CPI  R17,236
	BRSH _0xA
	RCALL _start_PWM
;     171         if( u_fb > MAX_STEPUP_LEVEL  ) PWM_stop();
_0xA:
	CPI  R17,239
	BRLO _0xB
	RCALL _PWM_stop
;     172 }
_0xB:
	LD   R17,Y+
	RET
;     173 
;     174 
;     175 void Go_To_Sleep(void) {
_Go_To_Sleep:
;     176         BUSSER_ON;
	SBI  0xB,1
;     177         PWM_stop();
	RCALL _PWM_stop
;     178         wdt_stop();
	RCALL _wdt_stop
;     179         AX_SLEEP_MODE;
	CBI  0x8,5
;     180         RESISTOR_OFF;
	CBI  0x4,5
;     181         delay_ms(600);
	LDI  R30,LOW(600)
	LDI  R31,HIGH(600)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
;     182         DIVIDER_OFF;
	CBI  0x4,7
;     183         BUSSER_OFF;
	CBI  0xB,1
;     184         sequrity_flag = 0;
	CLR  R8
;     185         ALARM_flag = 0;
	CLR  R5
;     186         button_count = 0;
	LDI  R30,0
	STS  _button_count,R30
	STS  _button_count+1,R30
;     187         but_count = 0;
	LDI  R30,0
	STS  _but_count,R30
	STS  _but_count+1,R30
;     188         bt_flag = 0;
	LDI  R30,LOW(0)
	STS  _bt_flag,R30
;     189         ADMUX = 0x00;       //      .
	STS  124,R30
;     190         ADCSRA = 0x00;
	STS  122,R30
;     191         while(KNOPA_PRESSED);
_0xC:
	SBIS 0x3,0
	RJMP _0xC
;     192         delay_ms(3000);
	LDI  R30,LOW(3000)
	LDI  R31,HIGH(3000)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
;     193         #asm("sei")
	sei
;     194         powerdown();
	RCALL _powerdown
;     195 }
	RET
;     196 
;     197 
;     198 void StartUp(void) {
_StartUp:
;     199 unsigned char i, data;
;     200 unsigned char limit = 0;
;     201 
;     202                 ADCSRA = 0x81;  //  
	RCALL __SAVELOCR4
;	i -> R17
;	data -> R16
;	limit -> R19
	LDI  R19,0
	LDI  R30,LOW(129)
	STS  122,R30
;     203                 delay_ms(10);
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
;     204                 i = read_adc(AVCC_SOURCE | BAT_CHARGE);   //     
	LDI  R30,LOW(110)
	ST   -Y,R30
	RCALL _read_adc
	MOV  R17,R30
;     205 
;     206                   BUSSER_ON;
	SBI  0xB,1
;     207                   delay_ms(250);
	LDI  R30,LOW(250)
	LDI  R31,HIGH(250)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
;     208                   data = read_adc(AVCC_SOURCE | BAT_CHARGE); //      
	LDI  R30,LOW(110)
	ST   -Y,R30
	RCALL _read_adc
	MOV  R16,R30
;     209                   BUSSER_OFF;
	CBI  0xB,1
;     210                   delay_ms(250);
	LDI  R30,LOW(250)
	LDI  R31,HIGH(250)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
;     211 
;     212                 ADMUX = 0x00;       //      .
	LDI  R30,LOW(0)
	STS  124,R30
;     213                 ADCSRA = 0x00;
	STS  122,R30
;     214 
;     215                         if( data > 107 ) limit = 1; //     2,6 ...
	CPI  R16,108
	BRLO _0xF
	LDI  R19,LOW(1)
;     216                         if( data > 117 ) limit = 2; //     2,4 ...
_0xF:
	CPI  R16,118
	BRLO _0x10
	LDI  R19,LOW(2)
;     217                         if( data > 127 ) limit = 5; //     2,2 ...
_0x10:
	CPI  R16,128
	BRLO _0x11
	LDI  R19,LOW(5)
;     218 
;     219                         for(i=0;i<limit;i++) {  //  .
_0x11:
	LDI  R17,LOW(0)
_0x13:
	CP   R17,R19
	BRSH _0x14
;     220                                 BUSSER_ON;
	SBI  0xB,1
;     221                                 delay_ms(250);
	LDI  R30,LOW(250)
	LDI  R31,HIGH(250)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
;     222                                 BUSSER_OFF;
	CBI  0xB,1
;     223                                 delay_ms(250);
	LDI  R30,LOW(250)
	LDI  R31,HIGH(250)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
;     224                                 }
	SUBI R17,-1
	RJMP _0x13
_0x14:
;     225 
;     226                         delay_ms(1500);
	LDI  R30,LOW(1500)
	LDI  R31,HIGH(1500)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
;     227 
;     228                         if( data > 127 ) { //   ,
	CPI  R16,128
	BRLO _0x15
;     229                                           Go_To_Sleep(); // ...
	RCALL _Go_To_Sleep
;     230                                          }
;     231 }
_0x15:
	RCALL __LOADLOCR4
	ADIW R28,4
	RET
;     232 
;     233 
;     234 
;     235 char Prepare_of_sequrity(void) {
_Prepare_of_sequrity:
;     236 unsigned char i_pr;
;     237 
;     238                          //  
;     239                         ADCSRA = 0x81;
	ST   -Y,R17
;	i_pr -> R17
	LDI  R30,LOW(129)
	STS  122,R30
;     240 
;     241                         delay_ms(500);
	LDI  R30,LOW(500)
	LDI  R31,HIGH(500)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
;     242 
;     243                         temp = read_adc(AVCC_SOURCE | RESISTOR); //  
	LDI  R30,LOW(102)
	ST   -Y,R30
	RCALL _read_adc
	MOV  R4,R30
;     244 
;     245                         for(i_pr=0;i_pr<15;i_pr++) {  //   15 .
	LDI  R17,LOW(0)
_0x17:
	CPI  R17,15
	BRSH _0x18
;     246                                 BUSSER_ON;
	SBI  0xB,1
;     247                                 delay_ms(100);
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
;     248                                 BUSSER_OFF;
	CBI  0xB,1
;     249                                 delay_ms(900);
	LDI  R30,LOW(900)
	LDI  R31,HIGH(900)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
;     250                                 }
	SUBI R17,-1
	RJMP _0x17
_0x18:
;     251 
;     252                         AX_WAKE_UP; //  
	SBI  0x8,5
;     253                         RESISTOR_ON; //  
	SBI  0x4,5
;     254                         delay_ms(10); //    
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
;     255 
;     256                         zero_R = read_adc(AVCC_SOURCE | RESISTOR);
	LDI  R30,LOW(102)
	ST   -Y,R30
	RCALL _read_adc
	MOV  R12,R30
;     257                           if(zero_R < 20) zero_R = 20; // ,     .
	LDI  R30,LOW(20)
	CP   R12,R30
	BRSH _0x19
	MOV  R12,R30
;     258 
;     259                         zero_X = read_adc(AVCC_SOURCE | X_AXIS);
_0x19:
	LDI  R30,LOW(98)
	ST   -Y,R30
	RCALL _read_adc
	MOV  R7,R30
;     260                           min_X = (zero_X - (zero_R / ALARM_DIVIDER));
	MOV  R30,R12
	LSR  R30
	LSR  R30
	MOV  R26,R30
	MOV  R30,R7
	SUB  R30,R26
	MOV  R11,R30
;     261                           max_X = (zero_X + (zero_R / ALARM_DIVIDER));
	MOV  R30,R12
	LSR  R30
	LSR  R30
	ADD  R30,R7
	STS  _max_X,R30
;     262 
;     263                         zero_Y = read_adc(AVCC_SOURCE | Y_AXIS);
	LDI  R30,LOW(99)
	ST   -Y,R30
	RCALL _read_adc
	MOV  R10,R30
;     264                           min_Y = (zero_Y - (zero_R / ALARM_DIVIDER));
	MOV  R30,R12
	LSR  R30
	LSR  R30
	MOV  R26,R30
	MOV  R30,R10
	SUB  R30,R26
	MOV  R14,R30
;     265                           max_Y = (zero_Y + (zero_R / ALARM_DIVIDER));
	MOV  R30,R12
	LSR  R30
	LSR  R30
	ADD  R30,R10
	STS  _max_Y,R30
;     266 
;     267                         zero_Z = read_adc(AVCC_SOURCE | Z_AXIS);
	LDI  R30,LOW(100)
	ST   -Y,R30
	RCALL _read_adc
	MOV  R9,R30
;     268                           min_Z = (zero_Z - (zero_R / ALARM_DIVIDER));
	MOV  R30,R12
	LSR  R30
	LSR  R30
	MOV  R26,R30
	MOV  R30,R9
	SUB  R30,R26
	MOV  R13,R30
;     269                           max_Z = (zero_Z + (zero_R / ALARM_DIVIDER));
	MOV  R30,R12
	LSR  R30
	LSR  R30
	ADD  R30,R9
	STS  _max_Z,R30
;     270 
;     271 
;     272                         RESISTOR_OFF; //  
	CBI  0x4,5
;     273                         AX_SLEEP_MODE; //  
	CBI  0x8,5
;     274                         PWM_stop();    //  PWM (  )
	RCALL _PWM_stop
;     275                         DIVIDER_OFF;   //    
	CBI  0x4,7
;     276                         BUSSER_OFF;    //    
	CBI  0xB,1
;     277                         ADMUX = 0x00;       //      .
	LDI  R30,LOW(0)
	STS  124,R30
;     278                         ADCSRA = 0x00;
	STS  122,R30
;     279 
;     280         button_count = 0;
	LDI  R30,0
	STS  _button_count,R30
	STS  _button_count+1,R30
;     281         sequrity_flag = 1;  //    
	LDI  R30,LOW(1)
	MOV  R8,R30
;     282         wdt_start();        //     0,5 .
	RCALL _wdt_start
;     283         powerdown();        //  
	RCALL _powerdown
;     284 
;     285   return 1;
	LDI  R30,LOW(1)
	LD   R17,Y+
	RET
;     286 }
;     287 
;     288 void Sequrity_Process(void) {
_Sequrity_Process:
;     289   unsigned char wtemp, i, count;
;     290 
;     291 if(ALARM_flag) { //         ,
	RCALL __SAVELOCR4
;	wtemp -> R17
;	i -> R16
;	count -> R19
	TST  R5
	BRNE PC+2
	RJMP _0x1A
;     292   Step_Up_Process(); //  .
	RCALL _Step_Up_Process
;     293   alarm_count++;
	LDS  R30,_alarm_count
	LDS  R31,_alarm_count+1
	ADIW R30,1
	STS  _alarm_count,R30
	STS  _alarm_count+1,R31
;     294   if(alarm_count < 32780/32) BUSSER_ON;
	LDS  R26,_alarm_count
	LDS  R27,_alarm_count+1
	CPI  R26,LOW(0x400)
	LDI  R30,HIGH(0x400)
	CPC  R27,R30
	BRSH _0x1B
	SBI  0xB,1
;     295                         else BUSSER_OFF;
	RJMP _0x1C
_0x1B:
	CBI  0xB,1
;     296 
;     297   if(alarm_count > 65000/32) alarm_count = 0;
_0x1C:
	LDS  R26,_alarm_count
	LDS  R27,_alarm_count+1
	CPI  R26,LOW(0x7F0)
	LDI  R30,HIGH(0x7F0)
	CPC  R27,R30
	BRLO _0x1D
	LDI  R30,0
	STS  _alarm_count,R30
	STS  _alarm_count+1,R30
;     298 
;     299   if((KNOPA_PRESSED)) button_count++;
_0x1D:
	SBIC 0x3,0
	RJMP _0x1E
	LDS  R30,_button_count
	LDS  R31,_button_count+1
	ADIW R30,1
	STS  _button_count,R30
	STS  _button_count+1,R31
;     300                  else button_count = 0;
	RJMP _0x1F
_0x1E:
	LDI  R30,0
	STS  _button_count,R30
	STS  _button_count+1,R30
;     301 
;     302   if(button_count > 32500) {  // ~8 .
_0x1F:
	LDS  R26,_button_count
	LDS  R27,_button_count+1
	CPI  R26,LOW(0x7EF5)
	LDI  R30,HIGH(0x7EF5)
	CPC  R27,R30
	BRLO _0x20
;     303         BUSSER_ON; //  ,       .
	SBI  0xB,1
;     304         PWM_stop(); //  .
	RCALL _PWM_stop
;     305         sequrity_flag = 0;   //  .
	CLR  R8
;     306         ALARM_flag = 0;
	CLR  R5
;     307         button_count = 0;
	LDI  R30,0
	STS  _button_count,R30
	STS  _button_count+1,R30
;     308         PORTB.3 = 1;   //    ( ).
	SBI  0x5,3
;     309         PORTB.4 = 0;
	CBI  0x5,4
;     310         AX_SLEEP_MODE;    //   .
	CBI  0x8,5
;     311         RESISTOR_OFF;
	CBI  0x4,5
;     312         ADMUX = 0x00;       //  .
	LDI  R30,LOW(0)
	STS  124,R30
;     313         ADCSRA = 0x00;
	STS  122,R30
;     314         delay_ms(20);
	LDI  R30,LOW(20)
	LDI  R31,HIGH(20)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
;     315         BUSSER_OFF;  //  .
	CBI  0xB,1
;     316         DIVIDER_OFF; //  ,         .
	CBI  0x4,7
;     317         while((KNOPA_PRESSED));
_0x25:
	SBIS 0x3,0
	RJMP _0x25
;     318         delay_ms(3000);
	LDI  R30,LOW(3000)
	LDI  R31,HIGH(3000)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
;     319         #asm("sei")
	sei
;     320         powerdown();
	RCALL _powerdown
;     321         }
;     322 
;     323 } else {
_0x20:
	RJMP _0x28
_0x1A:
;     324   AX_WAKE_UP;
	SBI  0x8,5
;     325   ADCSRA=0x81; //  
	LDI  R30,LOW(129)
	STS  122,R30
;     326 
;     327   delay_ms(4); //    .
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
;     328   temp = read_adc(AVCC_SOURCE | Y_AXIS);  //    .
	LDI  R30,LOW(99)
	ST   -Y,R30
	RCALL _read_adc
	MOV  R4,R30
;     329 
;     330   //     ,      :
;     331   wtemp = read_adc(AVCC_SOURCE | X_AXIS);
	LDI  R30,LOW(98)
	ST   -Y,R30
	RCALL _read_adc
	MOV  R17,R30
;     332   if( (wtemp > max_X) || (wtemp < min_X) ) {
	LDS  R30,_max_X
	CP   R30,R17
	BRLO _0x2A
	CP   R17,R11
	BRSH _0x29
_0x2A:
;     333         #asm("cli")
	cli
;     334         count = 0;
	LDI  R19,LOW(0)
;     335         for(i=0;i<5;i++) {
	LDI  R16,LOW(0)
_0x2D:
	CPI  R16,5
	BRSH _0x2E
;     336                 wtemp = read_adc(AVCC_SOURCE | X_AXIS);
	LDI  R30,LOW(98)
	ST   -Y,R30
	RCALL _read_adc
	MOV  R17,R30
;     337                 if( (wtemp > max_X) || (wtemp < min_X) ) count++;
	LDS  R30,_max_X
	CP   R30,R17
	BRLO _0x30
	CP   R17,R11
	BRSH _0x2F
_0x30:
	SUBI R19,-1
;     338                 }
_0x2F:
	SUBI R16,-1
	RJMP _0x2D
_0x2E:
;     339         if(count > 2) ALARM_flag = 1;
	CPI  R19,3
	BRLO _0x32
	LDI  R30,LOW(1)
	MOV  R5,R30
;     340         #asm("sei")
_0x32:
	sei
;     341         }
;     342 
;     343   wtemp = read_adc(AVCC_SOURCE | Y_AXIS);
_0x29:
	LDI  R30,LOW(99)
	ST   -Y,R30
	RCALL _read_adc
	MOV  R17,R30
;     344   if( (wtemp > max_Y) || (wtemp < min_Y) ) {
	LDS  R30,_max_Y
	CP   R30,R17
	BRLO _0x34
	CP   R17,R14
	BRSH _0x33
_0x34:
;     345         #asm("cli")
	cli
;     346         count = 0;
	LDI  R19,LOW(0)
;     347         for(i=0;i<5;i++) {
	LDI  R16,LOW(0)
_0x37:
	CPI  R16,5
	BRSH _0x38
;     348                 wtemp = read_adc(AVCC_SOURCE | Y_AXIS);
	LDI  R30,LOW(99)
	ST   -Y,R30
	RCALL _read_adc
	MOV  R17,R30
;     349                 if( (wtemp > max_Y) || (wtemp < min_Y) ) count++;
	LDS  R30,_max_Y
	CP   R30,R17
	BRLO _0x3A
	CP   R17,R14
	BRSH _0x39
_0x3A:
	SUBI R19,-1
;     350                 }
_0x39:
	SUBI R16,-1
	RJMP _0x37
_0x38:
;     351         if(count > 2) ALARM_flag = 1;
	CPI  R19,3
	BRLO _0x3C
	LDI  R30,LOW(1)
	MOV  R5,R30
;     352         #asm("sei")
_0x3C:
	sei
;     353         }
;     354 
;     355   wtemp = read_adc(AVCC_SOURCE | Z_AXIS);
_0x33:
	LDI  R30,LOW(100)
	ST   -Y,R30
	RCALL _read_adc
	MOV  R17,R30
;     356   if( (wtemp > max_Z) || (wtemp < min_Z) ) {
	LDS  R30,_max_Z
	CP   R30,R17
	BRLO _0x3E
	CP   R17,R13
	BRSH _0x3D
_0x3E:
;     357         #asm("cli")
	cli
;     358         count = 0;
	LDI  R19,LOW(0)
;     359         for(i=0;i<5;i++) {
	LDI  R16,LOW(0)
_0x41:
	CPI  R16,5
	BRSH _0x42
;     360                 wtemp = read_adc(AVCC_SOURCE | Z_AXIS);
	LDI  R30,LOW(100)
	ST   -Y,R30
	RCALL _read_adc
	MOV  R17,R30
;     361                 if( (wtemp > max_Z) || (wtemp < min_Z) ) count++;
	LDS  R30,_max_Z
	CP   R30,R17
	BRLO _0x44
	CP   R17,R13
	BRSH _0x43
_0x44:
	SUBI R19,-1
;     362                 }
_0x43:
	SUBI R16,-1
	RJMP _0x41
_0x42:
;     363         if(count > 2) ALARM_flag = 1;
	CPI  R19,3
	BRLO _0x46
	LDI  R30,LOW(1)
	MOV  R5,R30
;     364         #asm("sei")
_0x46:
	sei
;     365         }
;     366 
;     367   AX_SLEEP_MODE; //  
_0x3D:
	CBI  0x8,5
;     368 
;     369   if((KNOPA_PRESSED)) {  //      ,     .
	SBIC 0x3,0
	RJMP _0x47
;     370                          #asm("cli")
	cli
;     371                          but_count = 0;
	LDI  R30,0
	STS  _but_count,R30
	STS  _but_count+1,R30
;     372                          while( (KNOPA_PRESSED) && (but_count < 32500)) { // ,   .
_0x48:
	SBIC 0x3,0
	RJMP _0x4B
	LDS  R26,_but_count
	LDS  R27,_but_count+1
	CPI  R26,LOW(0x7EF4)
	LDI  R30,HIGH(0x7EF4)
	CPC  R27,R30
	BRLO _0x4C
_0x4B:
	RJMP _0x4A
_0x4C:
;     373                                 but_count++;
	LDS  R30,_but_count
	LDS  R31,_but_count+1
	ADIW R30,1
	STS  _but_count,R30
	STS  _but_count+1,R31
;     374                                 delay_us(100);
	__DELAY_USB 33
;     375                                 }
	RJMP _0x48
_0x4A:
;     376 
;     377                          if( but_count < 32500 ) { //        ( ~3 )
	LDS  R26,_but_count
	LDS  R27,_but_count+1
	CPI  R26,LOW(0x7EF4)
	LDI  R30,HIGH(0x7EF4)
	CPC  R27,R30
	BRSH _0x4D
;     378                                 if(but_count > 100) { //    0,1  (    )
	CPI  R26,LOW(0x65)
	LDI  R30,HIGH(0x65)
	CPC  R27,R30
	BRLO _0x4E
;     379                                                      ALARM_flag = 1;  //   
	LDI  R30,LOW(1)
	MOV  R5,R30
;     380                                                     }
;     381 
;     382                                 } else {
_0x4E:
	RJMP _0x4F
_0x4D:
;     383                                         ALARM_flag = 0;
	CLR  R5
;     384                                         bt_flag = 1;
	LDI  R30,LOW(1)
	STS  _bt_flag,R30
;     385                                         PORTB.3 = 1;   //    ( ).
	SBI  0x5,3
;     386                                         PORTB.4 = 0;
	CBI  0x5,4
;     387                                 }
_0x4F:
;     388                          #asm("sei")
	sei
;     389                         }
;     390 
;     391 
;     392 
;     393   if(ALARM_flag) { //        ,
_0x47:
	TST  R5
	BREQ _0x54
;     394         wdt_stop();   //  .
	RCALL _wdt_stop
;     395         DIVIDER_ON;   //    ,    .
	SBI  0x4,7
;     396         PORTB.3 = 0;  //    ( ).
	CBI  0x5,3
;     397         PORTB.4 = 1;
	SBI  0x5,4
;     398     } else {
	RJMP _0x59
_0x54:
;     399         ADMUX = 0x00;       //      .
	LDI  R30,LOW(0)
	STS  124,R30
;     400         ADCSRA = 0x00;
	STS  122,R30
;     401 
;     402         if(bt_flag) Go_To_Sleep();      //   .
	LDS  R30,_bt_flag
	CPI  R30,0
	BREQ _0x5A
	RCALL _Go_To_Sleep
;     403                else powerdown();        //  
	RJMP _0x5B
_0x5A:
	RCALL _powerdown
;     404     }
_0x5B:
_0x59:
;     405 
;     406 } // end of "} else {"
_0x28:
;     407 
;     408 }
	RCALL __LOADLOCR4
	ADIW R28,4
	RET
;     409 
;     410 
;     411 // Declare your global variables here
;     412 
;     413 void main(void)
;     414 {
_main:
;     415 //unsigned char ch_temp;
;     416 
;     417 // Input/Output Ports initialization
;     418 // Port B initialization
;     419 // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
;     420 // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=P
;     421 PORTB=0x01;
	LDI  R30,LOW(1)
	OUT  0x5,R30
;     422 DDRB=0x00;
	LDI  R30,LOW(0)
	OUT  0x4,R30
;     423 
;     424 // :   PB3  PB4    .
;     425 DDRB |= ((1<<3)|(1<<4));
	IN   R30,0x4
	ORI  R30,LOW(0x18)
	OUT  0x4,R30
;     426 PORTB.3 = 1;
	SBI  0x5,3
;     427 PORTB.4 = 0;
	CBI  0x5,4
;     428 // ********************************
;     429 
;     430 // Port C initialization
;     431 // Func6=In Func5=Out Func4=In Func3=In Func2=In Func1=Out Func0=Out
;     432 // State6=T State5=0 State4=T State3=T State2=T State1=0 State0=0
;     433 PORTC=0x00;
	LDI  R30,LOW(0)
	OUT  0x8,R30
;     434 DDRC=0x23;
	LDI  R30,LOW(35)
	OUT  0x7,R30
;     435 
;     436 // Port D initialization
;     437 // Func7=In Func6=In Func5=Out Func4=In Func3=In Func2=In Func1=Out Func0=In
;     438 // State7=T State6=T State5=0 State4=T State3=T State2=T State1=0 State0=T
;     439 PORTD=0x00;
	LDI  R30,LOW(0)
	OUT  0xB,R30
;     440 DDRD=0x22;
	LDI  R30,LOW(34)
	OUT  0xA,R30
;     441 
;     442 // Timer/Counter 0 initialization
;     443 // Clock source: System Clock
;     444 // Clock value: Timer 0 Stopped
;     445 // Mode: Normal top=FFh
;     446 // OC0A output: Disconnected
;     447 // OC0B output: Disconnected
;     448 TCCR0A=0x00;
	LDI  R30,LOW(0)
	OUT  0x24,R30
;     449 TCCR0B=0x00;
	OUT  0x25,R30
;     450 TCNT0=0x00;
	OUT  0x26,R30
;     451 OCR0A=0x00;
	OUT  0x27,R30
;     452 OCR0B=0x00;
	OUT  0x28,R30
;     453 
;     454 // Timer/Counter 1 initialization
;     455 // Clock source: System Clock
;     456 // Clock value: Timer 1 Stopped
;     457 // Mode: Normal top=FFFFh
;     458 // OC1A output: Discon.
;     459 // OC1B output: Discon.
;     460 // Noise Canceler: Off
;     461 // Input Capture on Falling Edge
;     462 // Timer 1 Overflow Interrupt: Off
;     463 // Input Capture Interrupt: Off
;     464 // Compare A Match Interrupt: Off
;     465 // Compare B Match Interrupt: Off
;     466 TCCR1A=0x00;
	STS  128,R30
;     467 TCCR1B=0x00;
	STS  129,R30
;     468 TCNT1H=0x00;
	STS  133,R30
;     469 TCNT1L=0x00;
	STS  132,R30
;     470 ICR1H=0x00;
	STS  135,R30
;     471 ICR1L=0x00;
	STS  134,R30
;     472 OCR1AH=0x00;
	STS  137,R30
;     473 OCR1AL=0x00;
	STS  136,R30
;     474 OCR1BH=0x00;
	STS  139,R30
;     475 OCR1BL=0x00;
	STS  138,R30
;     476 
;     477 // Timer/Counter 2 initialization
;     478 // Clock source: System Clock
;     479 // Clock value: Timer 2 Stopped
;     480 // Mode: Normal top=FFh
;     481 // OC2A output: Disconnected
;     482 // OC2B output: Disconnected
;     483 ASSR=0x00;
	STS  182,R30
;     484 TCCR2A=0x00;
	STS  176,R30
;     485 TCCR2B=0x00;
	STS  177,R30
;     486 TCNT2=0x00;
	STS  178,R30
;     487 OCR2A=0x00;
	STS  179,R30
;     488 OCR2B=0x00;
	STS  180,R30
;     489 
;     490 // External Interrupt(s) initialization
;     491 // INT0: Off
;     492 // INT1: Off
;     493 // Interrupt on any change on pins PCINT0-7: On
;     494 // Interrupt on any change on pins PCINT8-14: Off
;     495 // Interrupt on any change on pins PCINT16-23: Off
;     496 EICRA=0x00;
	STS  105,R30
;     497 EIMSK=0x00;
	OUT  0x1D,R30
;     498 PCICR=0x01;
	LDI  R30,LOW(1)
	STS  104,R30
;     499 PCMSK0=0x01;
	STS  107,R30
;     500 PCIFR=0x01;
	OUT  0x1B,R30
;     501 
;     502 // Timer/Counter 0 Interrupt(s) initialization
;     503 TIMSK0=0x00;
	LDI  R30,LOW(0)
	STS  110,R30
;     504 // Timer/Counter 1 Interrupt(s) initialization
;     505 TIMSK1=0x00;
	STS  111,R30
;     506 // Timer/Counter 2 Interrupt(s) initialization
;     507 TIMSK2=0x00;
	STS  112,R30
;     508 
;     509 // Analog Comparator initialization
;     510 // Analog Comparator: Off
;     511 // Analog Comparator Input Capture by Timer/Counter 1: Off
;     512 ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x30,R30
;     513 ADCSRB=0x00;
	LDI  R30,LOW(0)
	STS  123,R30
;     514 
;     515 // ADC initialization
;     516 // ADC Clock frequency: 500,000 kHz
;     517 // ADC Voltage Reference: AVCC pin
;     518 // ADC Auto Trigger Source: None
;     519 // Only the 8 most significant bits of
;     520 // the AD conversion result are used
;     521 // Digital input buffers on ADC0: On, ADC1: On, ADC2: On, ADC3: On
;     522 // ADC4: On, ADC5: On
;     523 DIDR0=0x00;
	STS  126,R30
;     524 //ADMUX = 0x60 & 0xff;
;     525 //ADCSRA=0x81;
;     526 ADMUX = 0x00;       //      .
	STS  124,R30
;     527 ADCSRA = 0x00;
	STS  122,R30
;     528 
;     529 sleep_enable(); //     .
	RCALL _sleep_enable
;     530 delay_ms(1000);
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
;     531 #asm("sei")  //  .
	sei
;     532 powerdown(); //   .
	RCALL _powerdown
;     533 
;     534 delay_ms(4); //       .
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
;     535 sleep_mode_flag = 0; //  
	CLR  R6
;     536 #asm("cli")   //  .
	cli
;     537 StartUp();    //   .
	RCALL _StartUp
;     538 
;     539 
;     540 while (1)
_0x60:
;     541       {
;     542       // ----         ----
;     543       if((KNOPA_PRESSED) && (sequrity_flag == 0)) {  //         ...
	SBIC 0x3,0
	RJMP _0x64
	LDI  R30,LOW(0)
	CP   R30,R8
	BREQ _0x65
_0x64:
	RJMP _0x63
_0x65:
;     544                          time_of_pressed = 0;
	CLR  R3
;     545                          PWM_stop(); //     PWM
	RCALL _PWM_stop
;     546                          while( (KNOPA_PRESSED) && (time_of_pressed < 250)) { // ,   .
_0x66:
	SBIC 0x3,0
	RJMP _0x69
	LDI  R30,LOW(250)
	CP   R3,R30
	BRLO _0x6A
_0x69:
	RJMP _0x68
_0x6A:
;     547                                 time_of_pressed++;
	INC  R3
;     548                                 delay_ms(12);
	LDI  R30,LOW(12)
	LDI  R31,HIGH(12)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
;     549                                 }
	RJMP _0x66
_0x68:
;     550                          if( time_of_pressed < 250 ) { //        ( ~3 )
	LDI  R30,LOW(250)
	CP   R3,R30
	BRSH _0x6B
;     551 
;     552                                         if(time_of_pressed > 10) { //    0,1  (    )
	LDI  R30,LOW(10)
	CP   R30,R3
	BRSH _0x6C
;     553                                                                   Prepare_of_sequrity(); //      .
	RCALL _Prepare_of_sequrity
;     554                                                                  }
;     555 
;     556                                 } else {
_0x6C:
	RJMP _0x6D
_0x6B:
;     557                                   sequrity_flag = 0;
	CLR  R8
;     558                                   PORTB.3 = 1;   //    ( ).
	SBI  0x5,3
;     559                                   PORTB.4 = 0;
	CBI  0x5,4
;     560                                   Go_To_Sleep();  //    .
	RCALL _Go_To_Sleep
;     561                                 }
_0x6D:
;     562                         }
;     563 
;     564         // ----       ----
;     565         if(sleep_mode_flag) {
_0x63:
	TST  R6
	BREQ _0x72
;     566                              sleep_mode_flag = 0;
	CLR  R6
;     567                              #asm("cli")
	cli
;     568                              StartUp(); //   
	RCALL _StartUp
;     569                             }
;     570 
;     571         // ----     ----
;     572         if(sequrity_flag) Sequrity_Process(); //   -     .
_0x72:
	TST  R8
	BREQ _0x73
	RCALL _Sequrity_Process
;     573       };
_0x73:
	RJMP _0x60
;     574 }
_0x74:
	RJMP _0x74

	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x01
	.EQU __sm_mask=0x0E
	.EQU __sm_adc_noise_red=0x02
	.EQU __sm_powerdown=0x04
	.EQU __sm_powersave=0x06
	.EQU __sm_standby=0x0C
	.SET power_ctrl_reg=smcr
	#endif
_sleep_enable:
   in   r30,power_ctrl_reg
   sbr  r30,__se_bit
   out  power_ctrl_reg,r30
	RET
_powerdown:
   in   r30,power_ctrl_reg
   cbr  r30,__sm_mask
   sbr  r30,__sm_powerdown
   out  power_ctrl_reg,r30
   sleep
	RET

_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0xFA
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

;END OF CODE MARKER
__END_OF_CODE:
