/*****************************************************
This program was produced by the
CodeWizardAVR V1.25.9 Professional
Automatic Program Generator
 Copyright 1998-2008 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project :
Version :
Date    : 07.04.2009
Author  : Dikoy
Company : NT
Comments:


Chip type           : ATmega48V
Clock frequency     : 1,000000 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 128
*****************************************************/

#include <mega48.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x01
	.EQU __sm_mask=0x0E
	.EQU __sm_adc_noise_red=0x02
	.EQU __sm_powerdown=0x04
	.EQU __sm_powersave=0x06
	.EQU __sm_standby=0x0C
	.SET power_ctrl_reg=smcr
	#endif
#include <sleep.h>
#include <delay.h>


#define PWM_OUT     5
#define BUSSER_ON   PORTD |= (1<<1)
#define BUSSER_OFF  PORTD &= ~(1<<1)
#define BAT_CHARGE  0x0E
#define X_AXIS 2
#define Y_AXIS 3
#define Z_AXIS 4
#define RESISTOR 6
#define PWM_FB   7
#define AX_SLEEP_MODE  PORTC&=~(1<<5) //    
#define AX_WAKE_UP     PORTC|=(1<<5)  //  
#define AVCC_SOURCE  0x60  //    - 
#define AINT_SOURCE  0xE0  //  
#define MIN_STEPUP_LEVEL   (226+10)  //      , 13,7V
#define MAX_STEPUP_LEVEL   (228+10)  //      , 14V
#define DIVIDER_ON   DDRB|=(1<<7)
#define DIVIDER_OFF  DDRB&=~(1<<7)
#define RESISTOR_ON   DDRB|=(1<<5)
#define RESISTOR_OFF  DDRB&=~(1<<5)
#define KNOPA_PRESSED  ( !(PINB & (1<<0)) )
#define ALARM_DIVIDER   4


// *** ***
unsigned char temp, time_of_pressed;
unsigned char sleep_mode_flag = 0;
unsigned char ALARM_flag = 0;
unsigned char sequrity_flag = 0;
unsigned char zero_X, zero_Y, zero_Z, zero_R;
unsigned char min_X, min_Y, min_Z;
unsigned char max_X, max_Y, max_Z;
unsigned int  alarm_count = 0;
unsigned char bt_flag = 0;

unsigned int button_count = 0;
unsigned int but_count = 0;

//unsigned char first_flag = 1;

// ******

// Pin change 0-7 interrupt service routine
interrupt [PCINT0] void pin_change_isr0(void)
{
if(sequrity_flag == 0) {
        while(KNOPA_PRESSED);
        sleep_mode_flag = 1;
        #asm("cli")
        delay_ms(500);
        }
}


// Watchdog timeout interrupt service routine
interrupt [WDT] void wdt_timeout_isr(void) {

        #asm("nop")

}

void wdt_start(void) {
        // Watchdog Timer initialization
        // Watchdog Timer Prescaler: OSC/64k
        // Watchdog Timer interrupt: On
        #pragma optsize-
        #asm("wdr")
        WDTCSR = (1<<4) | (1<<3);  // (1<<WDCE) | (1<<WDE)
        WDTCSR = (1<<6) | (1<<2) | (1<<0);  // (1<<WDIE) | (1<<WDP2) | (1<<WDP0)

        #ifdef _OPTIMIZE_SIZE_
        #pragma optsize+
        #endif

        // Global enable interrupts
        #asm("sei")
}


void wdt_stop(void) {
        #pragma optsize-
        #asm("wdr")
        WDTCSR = (1<<4) | (1<<3);  // (1<<WDCE) | (1<<WDE)
        WDTCSR = 0;
        #ifdef _OPTIMIZE_SIZE_
        #pragma optsize+
        #endif

        #asm("cli")
}



// Read the 8 most significant bits
// of the AD conversion result
unsigned char read_adc(unsigned char adc_par)
{
ADMUX = adc_par;
// Delay needed for the stabilization of the ADC input voltage
delay_us(10);
// Start the AD conversion
ADCSRA|=0x40;
// Wait for the AD conversion to complete
while ((ADCSRA & 0x10)==0);
ADCSRA|=0x10;
return ADCH;
}


void start_PWM(void) {
// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: 1000,000 kHz
// Mode: CTC top=OCR0A
// OC0A output: Disconnected
// OC0B output: Toggle on compare match
TCCR0A=0x12;
TCCR0B=0x01;
}

void PWM_stop(void) {
TCCR0A=0x00;
TCCR0B=0x00;

PORTD &= ~(1<<PWM_OUT);
}


void Step_Up_Process(void) {
unsigned char u_fb;

        u_fb = read_adc(AINT_SOURCE | PWM_FB);

        if( u_fb < MIN_STEPUP_LEVEL  ) start_PWM();
        if( u_fb > MAX_STEPUP_LEVEL  ) PWM_stop();
}


void Go_To_Sleep(void) {
        BUSSER_ON;
        PWM_stop();
        wdt_stop();
        AX_SLEEP_MODE;
        RESISTOR_OFF;
        delay_ms(600);
        DIVIDER_OFF;
        BUSSER_OFF;
        sequrity_flag = 0;
        ALARM_flag = 0;
        button_count = 0;
        but_count = 0;
        bt_flag = 0;
        ADMUX = 0x00;       //      .
        ADCSRA = 0x00;
        while(KNOPA_PRESSED);
        delay_ms(3000);
        #asm("sei")
        powerdown();
}


void StartUp(void) {
unsigned char i, data;
unsigned char limit = 0;

                ADCSRA = 0x81;  //  
                delay_ms(10);
                i = read_adc(AVCC_SOURCE | BAT_CHARGE);   //     

                  BUSSER_ON;
                  delay_ms(250);
                  data = read_adc(AVCC_SOURCE | BAT_CHARGE); //      
                  BUSSER_OFF;
                  delay_ms(250);

                ADMUX = 0x00;       //      .
                ADCSRA = 0x00;

                        if( data > 107 ) limit = 1; //     2,6 ...
                        if( data > 117 ) limit = 2; //     2,4 ...
                        if( data > 127 ) limit = 5; //     2,2 ...

                        for(i=0;i<limit;i++) {  //  .
                                BUSSER_ON;
                                delay_ms(250);
                                BUSSER_OFF;
                                delay_ms(250);
                                }

                        delay_ms(1500);

                        if( data > 127 ) { //   ,
                                          Go_To_Sleep(); // ...
                                         }
}



char Prepare_of_sequrity(void) {
unsigned char i_pr;

                         //  
                        ADCSRA = 0x81;

                        delay_ms(500);

                        temp = read_adc(AVCC_SOURCE | RESISTOR); //  

                        for(i_pr=0;i_pr<15;i_pr++) {  //   15 .
                                BUSSER_ON;
                                delay_ms(100);
                                BUSSER_OFF;
                                delay_ms(900);
                                }

                        AX_WAKE_UP; //  
                        RESISTOR_ON; //  
                        delay_ms(10); //    

                        zero_R = read_adc(AVCC_SOURCE | RESISTOR);
                          if(zero_R < 20) zero_R = 20; // ,     .

                        zero_X = read_adc(AVCC_SOURCE | X_AXIS);
                          min_X = (zero_X - (zero_R / ALARM_DIVIDER));
                          max_X = (zero_X + (zero_R / ALARM_DIVIDER));

                        zero_Y = read_adc(AVCC_SOURCE | Y_AXIS);
                          min_Y = (zero_Y - (zero_R / ALARM_DIVIDER));
                          max_Y = (zero_Y + (zero_R / ALARM_DIVIDER));

                        zero_Z = read_adc(AVCC_SOURCE | Z_AXIS);
                          min_Z = (zero_Z - (zero_R / ALARM_DIVIDER));
                          max_Z = (zero_Z + (zero_R / ALARM_DIVIDER));


                        RESISTOR_OFF; //  
                        AX_SLEEP_MODE; //  
                        PWM_stop();    //  PWM (  )
                        DIVIDER_OFF;   //    
                        BUSSER_OFF;    //    
                        ADMUX = 0x00;       //      .
                        ADCSRA = 0x00;

        button_count = 0;
        sequrity_flag = 1;  //    
        wdt_start();        //     0,5 .
        powerdown();        //  

  return 1;
}

void Sequrity_Process(void) {
  unsigned char wtemp, i, count;

if(ALARM_flag) { //         ,
  Step_Up_Process(); //  .
  alarm_count++;
  if(alarm_count < 32780/32) BUSSER_ON;
                        else BUSSER_OFF;

  if(alarm_count > 65000/32) alarm_count = 0;

  if((KNOPA_PRESSED)) button_count++;
                 else button_count = 0;

  if(button_count > 32500) {  // ~8 .
        BUSSER_ON; //  ,       .
        PWM_stop(); //  .
        sequrity_flag = 0;   //  .
        ALARM_flag = 0;
        button_count = 0;
        PORTB.3 = 1;   //    ( ).
        PORTB.4 = 0;
        AX_SLEEP_MODE;    //   .
        RESISTOR_OFF;
        ADMUX = 0x00;       //  .
        ADCSRA = 0x00;
        delay_ms(20);
        BUSSER_OFF;  //  .
        DIVIDER_OFF; //  ,         .
        while((KNOPA_PRESSED));
        delay_ms(3000);
        #asm("sei")
        powerdown();
        }

} else {
  AX_WAKE_UP;
  ADCSRA=0x81; //  

  delay_ms(4); //    .
  temp = read_adc(AVCC_SOURCE | Y_AXIS);  //    .

  //     ,      :
  wtemp = read_adc(AVCC_SOURCE | X_AXIS);
  if( (wtemp > max_X) || (wtemp < min_X) ) {
        #asm("cli")
        count = 0;
        for(i=0;i<5;i++) {
                wtemp = read_adc(AVCC_SOURCE | X_AXIS);
                if( (wtemp > max_X) || (wtemp < min_X) ) count++;
                }
        if(count > 2) ALARM_flag = 1;
        #asm("sei")
        }

  wtemp = read_adc(AVCC_SOURCE | Y_AXIS);
  if( (wtemp > max_Y) || (wtemp < min_Y) ) {
        #asm("cli")
        count = 0;
        for(i=0;i<5;i++) {
                wtemp = read_adc(AVCC_SOURCE | Y_AXIS);
                if( (wtemp > max_Y) || (wtemp < min_Y) ) count++;
                }
        if(count > 2) ALARM_flag = 1;
        #asm("sei")
        }

  wtemp = read_adc(AVCC_SOURCE | Z_AXIS);
  if( (wtemp > max_Z) || (wtemp < min_Z) ) {
        #asm("cli")
        count = 0;
        for(i=0;i<5;i++) {
                wtemp = read_adc(AVCC_SOURCE | Z_AXIS);
                if( (wtemp > max_Z) || (wtemp < min_Z) ) count++;
                }
        if(count > 2) ALARM_flag = 1;
        #asm("sei")
        }

  AX_SLEEP_MODE; //  

  if((KNOPA_PRESSED)) {  //      ,     .
                         #asm("cli")
                         but_count = 0;
                         while( (KNOPA_PRESSED) && (but_count < 32500)) { // ,   .
                                but_count++;
                                delay_us(100);
                                }

                         if( but_count < 32500 ) { //        ( ~3 )
                                if(but_count > 100) { //    0,1  (    )
                                                     ALARM_flag = 1;  //   
                                                    }

                                } else {
                                        ALARM_flag = 0;
                                        bt_flag = 1;
                                        PORTB.3 = 1;   //    ( ).
                                        PORTB.4 = 0;
                                }
                         #asm("sei")
                        }



  if(ALARM_flag) { //        ,
        wdt_stop();   //  .
        DIVIDER_ON;   //    ,    .
        PORTB.3 = 0;  //    ( ).
        PORTB.4 = 1;
    } else {
        ADMUX = 0x00;       //      .
        ADCSRA = 0x00;

        if(bt_flag) Go_To_Sleep();      //   .
               else powerdown();        //  
    }

} // end of "} else {"

}


// Declare your global variables here

void main(void)
{
//unsigned char ch_temp;

// Input/Output Ports initialization
// Port B initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=P
PORTB=0x01;
DDRB=0x00;

// :   PB3  PB4    .
DDRB |= ((1<<3)|(1<<4));
PORTB.3 = 1;
PORTB.4 = 0;
// ********************************

// Port C initialization
// Func6=In Func5=Out Func4=In Func3=In Func2=In Func1=Out Func0=Out
// State6=T State5=0 State4=T State3=T State2=T State1=0 State0=0
PORTC=0x00;
DDRC=0x23;

// Port D initialization
// Func7=In Func6=In Func5=Out Func4=In Func3=In Func2=In Func1=Out Func0=In
// State7=T State6=T State5=0 State4=T State3=T State2=T State1=0 State0=T
PORTD=0x00;
DDRD=0x22;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: Timer 0 Stopped
// Mode: Normal top=FFh
// OC0A output: Disconnected
// OC0B output: Disconnected
TCCR0A=0x00;
TCCR0B=0x00;
TCNT0=0x00;
OCR0A=0x00;
OCR0B=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: Timer 1 Stopped
// Mode: Normal top=FFFFh
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer 1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
TCCR1A=0x00;
TCCR1B=0x00;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer 2 Stopped
// Mode: Normal top=FFh
// OC2A output: Disconnected
// OC2B output: Disconnected
ASSR=0x00;
TCCR2A=0x00;
TCCR2B=0x00;
TCNT2=0x00;
OCR2A=0x00;
OCR2B=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
// Interrupt on any change on pins PCINT0-7: On
// Interrupt on any change on pins PCINT8-14: Off
// Interrupt on any change on pins PCINT16-23: Off
EICRA=0x00;
EIMSK=0x00;
PCICR=0x01;
PCMSK0=0x01;
PCIFR=0x01;

// Timer/Counter 0 Interrupt(s) initialization
TIMSK0=0x00;
// Timer/Counter 1 Interrupt(s) initialization
TIMSK1=0x00;
// Timer/Counter 2 Interrupt(s) initialization
TIMSK2=0x00;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
ADCSRB=0x00;

// ADC initialization
// ADC Clock frequency: 500,000 kHz
// ADC Voltage Reference: AVCC pin
// ADC Auto Trigger Source: None
// Only the 8 most significant bits of
// the AD conversion result are used
// Digital input buffers on ADC0: On, ADC1: On, ADC2: On, ADC3: On
// ADC4: On, ADC5: On
DIDR0=0x00;
//ADMUX = 0x60 & 0xff;
//ADCSRA=0x81;
ADMUX = 0x00;       //      .
ADCSRA = 0x00;

sleep_enable(); //     .
delay_ms(1000);
#asm("sei")  //  .
powerdown(); //   .

delay_ms(4); //       .
sleep_mode_flag = 0; //  
#asm("cli")   //  .
StartUp();    //   .


while (1)
      {
      // ----         ----
      if((KNOPA_PRESSED) && (sequrity_flag == 0)) {  //         ...
                         time_of_pressed = 0;
                         PWM_stop(); //     PWM
                         while( (KNOPA_PRESSED) && (time_of_pressed < 250)) { // ,   .
                                time_of_pressed++;
                                delay_ms(12);
                                }
                         if( time_of_pressed < 250 ) { //        ( ~3 )

                                        if(time_of_pressed > 10) { //    0,1  (    )
                                                                  Prepare_of_sequrity(); //      .
                                                                 }

                                } else {
                                  sequrity_flag = 0;
                                  PORTB.3 = 1;   //    ( ).
                                  PORTB.4 = 0;
                                  Go_To_Sleep();  //    .
                                }
                        }

        // ----       ----
        if(sleep_mode_flag) {
                             sleep_mode_flag = 0;
                             #asm("cli")
                             StartUp(); //   
                            }

        // ----     ----
        if(sequrity_flag) Sequrity_Process(); //   -     .
      };
}
